/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the NotificationStateUpdate type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NotificationStateUpdate{}

// NotificationStateUpdate struct for NotificationStateUpdate
type NotificationStateUpdate struct {
	ReadAt *string `json:"read_at,omitempty"`
	Mute *bool `json:"mute,omitempty"`
}

// NewNotificationStateUpdate instantiates a new NotificationStateUpdate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNotificationStateUpdate() *NotificationStateUpdate {
	this := NotificationStateUpdate{}
	return &this
}

// NewNotificationStateUpdateWithDefaults instantiates a new NotificationStateUpdate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNotificationStateUpdateWithDefaults() *NotificationStateUpdate {
	this := NotificationStateUpdate{}
	return &this
}

// GetReadAt returns the ReadAt field value if set, zero value otherwise.
func (o *NotificationStateUpdate) GetReadAt() string {
	if o == nil || IsNil(o.ReadAt) {
		var ret string
		return ret
	}
	return *o.ReadAt
}

// GetReadAtOk returns a tuple with the ReadAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NotificationStateUpdate) GetReadAtOk() (*string, bool) {
	if o == nil || IsNil(o.ReadAt) {
		return nil, false
	}
	return o.ReadAt, true
}

// HasReadAt returns a boolean if a field has been set.
func (o *NotificationStateUpdate) HasReadAt() bool {
	if o != nil && !IsNil(o.ReadAt) {
		return true
	}

	return false
}

// SetReadAt gets a reference to the given string and assigns it to the ReadAt field.
func (o *NotificationStateUpdate) SetReadAt(v string) {
	o.ReadAt = &v
}

// GetMute returns the Mute field value if set, zero value otherwise.
func (o *NotificationStateUpdate) GetMute() bool {
	if o == nil || IsNil(o.Mute) {
		var ret bool
		return ret
	}
	return *o.Mute
}

// GetMuteOk returns a tuple with the Mute field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NotificationStateUpdate) GetMuteOk() (*bool, bool) {
	if o == nil || IsNil(o.Mute) {
		return nil, false
	}
	return o.Mute, true
}

// HasMute returns a boolean if a field has been set.
func (o *NotificationStateUpdate) HasMute() bool {
	if o != nil && !IsNil(o.Mute) {
		return true
	}

	return false
}

// SetMute gets a reference to the given bool and assigns it to the Mute field.
func (o *NotificationStateUpdate) SetMute(v bool) {
	o.Mute = &v
}

func (o NotificationStateUpdate) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NotificationStateUpdate) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ReadAt) {
		toSerialize["read_at"] = o.ReadAt
	}
	if !IsNil(o.Mute) {
		toSerialize["mute"] = o.Mute
	}
	return toSerialize, nil
}

type NullableNotificationStateUpdate struct {
	value *NotificationStateUpdate
	isSet bool
}

func (v NullableNotificationStateUpdate) Get() *NotificationStateUpdate {
	return v.value
}

func (v *NullableNotificationStateUpdate) Set(val *NotificationStateUpdate) {
	v.value = val
	v.isSet = true
}

func (v NullableNotificationStateUpdate) IsSet() bool {
	return v.isSet
}

func (v *NullableNotificationStateUpdate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNotificationStateUpdate(val *NotificationStateUpdate) *NullableNotificationStateUpdate {
	return &NullableNotificationStateUpdate{value: val, isSet: true}
}

func (v NullableNotificationStateUpdate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNotificationStateUpdate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


